from __future__ import annotations
from opendaq.opendaq import AndSearchFilter
from opendaq.opendaq import AnySearchFilter
from opendaq.opendaq import ArgumentInfo
from opendaq.opendaq import BaseObject
from opendaq.opendaq import BasicFileLoggerSink
from opendaq.opendaq import BlockReader
from opendaq.opendaq import BlockReaderFromExisting
from opendaq.opendaq import BlockReaderStatus
from opendaq.opendaq import BoolProperty
from opendaq.opendaq import BoolPropertyBuilder
from opendaq.opendaq import Boolean
from opendaq.opendaq import CallableInfo
from opendaq.opendaq import Client
from opendaq.opendaq import CmdLineArgsConfigProvider
from opendaq.opendaq import Coercer
from opendaq.opendaq import ComplexNumber
from opendaq.opendaq import Component
from opendaq.opendaq import ComponentStatusContainer
from opendaq.opendaq import Connection
from opendaq.opendaq import ConstantDataRule
from opendaq.opendaq import Context
from opendaq.opendaq import CoreType
from opendaq.opendaq import CustomSearchFilter
from opendaq.opendaq import DataDescriptorBuilder
from opendaq.opendaq import DataDescriptorBuilderFromExisting
from opendaq.opendaq import DataDescriptorChangedEventPacket
from opendaq.opendaq import DataDescriptorFromBuilder
from opendaq.opendaq import DataPacket
from opendaq.opendaq import DataPacketWithDomain
from opendaq.opendaq import DataRule
from opendaq.opendaq import DataRuleBuilder
from opendaq.opendaq import DataRuleBuilderFromExisting
from opendaq.opendaq import DataRuleFromBuilder
from opendaq.opendaq import DataRuleType
from opendaq.opendaq import DeviceDomain
from opendaq.opendaq import DeviceInfoConfig
from opendaq.opendaq import DeviceInfoConfigWithCustomSdkVersion
from opendaq.opendaq import DeviceType
from opendaq.opendaq import Dict
from opendaq.opendaq import DictProperty
from opendaq.opendaq import DictPropertyBuilder
from opendaq.opendaq import Dimension
from opendaq.opendaq import DimensionBuilder
from opendaq.opendaq import DimensionBuilderFromExisting
from opendaq.opendaq import DimensionFromBuilder
from opendaq.opendaq import DimensionRule
from opendaq.opendaq import DimensionRuleBuilder
from opendaq.opendaq import DimensionRuleBuilderFromExisting
from opendaq.opendaq import DimensionRuleFromBuilder
from opendaq.opendaq import DimensionRuleType
from opendaq.opendaq import Enumeration
from opendaq.opendaq import EnumerationProperty
from opendaq.opendaq import EnumerationPropertyBuilder
from opendaq.opendaq import EnumerationType
from opendaq.opendaq import EnumerationTypeWithValues
from opendaq.opendaq import EnumerationWithType
from opendaq.opendaq import EnvConfigProvider
from opendaq.opendaq import EvalValue
from opendaq.opendaq import EvalValueArgs
from opendaq.opendaq import EvalValueFunc
from opendaq.opendaq import EventArgs
from opendaq.opendaq import EventPacket
from opendaq.opendaq import ExcludedTagsSearchFilter
from opendaq.opendaq import ExplicitDataRule
from opendaq.opendaq import ExplicitDomainDataRule
from opendaq.opendaq import ExternalAllocator
from opendaq.opendaq import Float
from opendaq.opendaq import FloatProperty
from opendaq.opendaq import FloatPropertyBuilder
from opendaq.opendaq import Folder
from opendaq.opendaq import FolderWithItemType
from opendaq.opendaq import Function
from opendaq.opendaq import FunctionBlockType
from opendaq.opendaq import FunctionProperty
from opendaq.opendaq import FunctionPropertyBuilder
from opendaq.opendaq import IAllocator
from opendaq.opendaq import IArgumentInfo
from opendaq.opendaq import IAwaitable
from opendaq.opendaq import IBaseObject
from opendaq.opendaq import IBlockReader
from opendaq.opendaq import IBlockReaderStatus
from opendaq.opendaq import IBoolean
from opendaq.opendaq import ICallableInfo
from opendaq.opendaq import IChannel
from opendaq.opendaq import ICoercer
from opendaq.opendaq import IComplexNumber
from opendaq.opendaq import IComponent
from opendaq.opendaq import IComponentPrivate
from opendaq.opendaq import IComponentStatusContainer
from opendaq.opendaq import IComponentStatusContainerPrivate
from opendaq.opendaq import IComponentType
from opendaq.opendaq import IConfigProvider
from opendaq.opendaq import IConnection
from opendaq.opendaq import IContext
from opendaq.opendaq import IDataDescriptor
from opendaq.opendaq import IDataDescriptorBuilder
from opendaq.opendaq import IDataPacket
from opendaq.opendaq import IDataRule
from opendaq.opendaq import IDataRuleBuilder
from opendaq.opendaq import IDevice
from opendaq.opendaq import IDeviceDomain
from opendaq.opendaq import IDeviceInfo
from opendaq.opendaq import IDeviceInfoConfig
from opendaq.opendaq import IDeviceType
from opendaq.opendaq import IDict
from opendaq.opendaq import IDimension
from opendaq.opendaq import IDimensionBuilder
from opendaq.opendaq import IDimensionRule
from opendaq.opendaq import IDimensionRuleBuilder
from opendaq.opendaq import IEnumeration
from opendaq.opendaq import IEnumerationType
from opendaq.opendaq import IEvalValue
from opendaq.opendaq import IEventArgs
from opendaq.opendaq import IEventPacket
from opendaq.opendaq import IFloat
from opendaq.opendaq import IFolder
from opendaq.opendaq import IFolderConfig
from opendaq.opendaq import IFunction
from opendaq.opendaq import IFunctionBlock
from opendaq.opendaq import IFunctionBlockType
from opendaq.opendaq import IGraphVisualization
from opendaq.opendaq import IInputPort
from opendaq.opendaq import IInputPortConfig
from opendaq.opendaq import IInputPortNotifications
from opendaq.opendaq import IInstance
from opendaq.opendaq import IInstanceBuilder
from opendaq.opendaq import IInteger
from opendaq.opendaq import IIterable
from opendaq.opendaq import IIterator
from opendaq.opendaq import IList
from opendaq.opendaq import ILogger
from opendaq.opendaq import ILoggerComponent
from opendaq.opendaq import ILoggerSink
from opendaq.opendaq import ILoggerThreadPool
from opendaq.opendaq import IMirroredSignalConfig
from opendaq.opendaq import IMirroredSignalPrivate
from opendaq.opendaq import IModule
from opendaq.opendaq import IModuleManager
from opendaq.opendaq import INumber
from opendaq.opendaq import IOwnable
from opendaq.opendaq import IPacket
from opendaq.opendaq import IPacketDestructCallback
from opendaq.opendaq import IPacketReader
from opendaq.opendaq import IProcedure
from opendaq.opendaq import IProperty
from opendaq.opendaq import IPropertyBuilder
from opendaq.opendaq import IPropertyObject
from opendaq.opendaq import IPropertyObjectClass
from opendaq.opendaq import IPropertyObjectClassBuilder
from opendaq.opendaq import IPropertyObjectProtected
from opendaq.opendaq import IPropertyValueEventArgs
from opendaq.opendaq import IRange
from opendaq.opendaq import IRatio
from opendaq.opendaq import IReader
from opendaq.opendaq import IReaderStatus
from opendaq.opendaq import IRemovable
from opendaq.opendaq import ISampleReader
from opendaq.opendaq import IScaling
from opendaq.opendaq import IScalingBuilder
from opendaq.opendaq import IScheduler
from opendaq.opendaq import ISearchFilter
from opendaq.opendaq import IServer
from opendaq.opendaq import IServerCapability
from opendaq.opendaq import IServerType
from opendaq.opendaq import ISignal
from opendaq.opendaq import ISignalConfig
from opendaq.opendaq import ISignalEvents
from opendaq.opendaq import ISimpleType
from opendaq.opendaq import IStreamReader
from opendaq.opendaq import IStreaming
from opendaq.opendaq import IString
from opendaq.opendaq import IStruct
from opendaq.opendaq import IStructBuilder
from opendaq.opendaq import IStructType
from opendaq.opendaq import ISubscriptionEventArgs
from opendaq.opendaq import ITags
from opendaq.opendaq import ITagsPrivate
from opendaq.opendaq import ITailReader
from opendaq.opendaq import ITask
from opendaq.opendaq import ITaskGraph
from opendaq.opendaq import IType
from opendaq.opendaq import ITypeManager
from opendaq.opendaq import IUnit
from opendaq.opendaq import IUnitBuilder
from opendaq.opendaq import IValidator
from opendaq.opendaq import InputPort
from opendaq.opendaq import InstanceBuilder
from opendaq.opendaq import InstanceFromBuilder
from opendaq.opendaq import IntProperty
from opendaq.opendaq import IntPropertyBuilder
from opendaq.opendaq import Integer
from opendaq.opendaq import InterfaceIdSearchFilter
from opendaq.opendaq import IoFolder
from opendaq.opendaq import JsonConfigProvider
from opendaq.opendaq import LinearDataRule
from opendaq.opendaq import LinearDimensionRule
from opendaq.opendaq import LinearScaling
from opendaq.opendaq import List
from opendaq.opendaq import ListDimensionRule
from opendaq.opendaq import ListProperty
from opendaq.opendaq import ListPropertyBuilder
from opendaq.opendaq import LocalIdSearchFilter
from opendaq.opendaq import LogLevel
from opendaq.opendaq import LogarithmicDimensionRule
from opendaq.opendaq import Logger
from opendaq.opendaq import LoggerComponent
from opendaq.opendaq import LoggerThreadPool
from opendaq.opendaq import MallocAllocator
from opendaq.opendaq import MockSignal
from opendaq.opendaq import ModuleManager
from opendaq.opendaq import ModuleManagerMultiplePaths
from opendaq.opendaq import NotSearchFilter
from opendaq.opendaq import ObjectProperty
from opendaq.opendaq import ObjectPropertyBuilder
from opendaq.opendaq import OrSearchFilter
from opendaq.opendaq import PacketReader
from opendaq.opendaq import PacketReaderFromPort
from opendaq.opendaq import PacketReadyNotification
from opendaq.opendaq import PacketType
from opendaq.opendaq import Procedure
from opendaq.opendaq import PropertyBuilder
from opendaq.opendaq import PropertyEventType
from opendaq.opendaq import PropertyObject
from opendaq.opendaq import PropertyObjectClassBuilder
from opendaq.opendaq import PropertyObjectClassBuilderWithManager
from opendaq.opendaq import PropertyObjectClassFromBuilder
from opendaq.opendaq import PropertyObjectWithClassAndManager
from opendaq.opendaq import PropertyValueEventArgs
from opendaq.opendaq import ProtocolType
from opendaq.opendaq import Range
from opendaq.opendaq import Ratio
from opendaq.opendaq import RatioProperty
from opendaq.opendaq import RatioPropertyBuilder
from opendaq.opendaq import ReadMode
from opendaq.opendaq import ReadStatus
from opendaq.opendaq import ReadTimeoutType
from opendaq.opendaq import ReaderStatus
from opendaq.opendaq import RecursiveSearchFilter
from opendaq.opendaq import ReferenceProperty
from opendaq.opendaq import ReferencePropertyBuilder
from opendaq.opendaq import RequiredTagsSearchFilter
from opendaq.opendaq import RotatingFileLoggerSink
from opendaq.opendaq import SampleType
from opendaq.opendaq import ScaledSampleType
from opendaq.opendaq import Scaling
from opendaq.opendaq import ScalingBuilder
from opendaq.opendaq import ScalingBuilderFromExisting
from opendaq.opendaq import ScalingFromBuilder
from opendaq.opendaq import ScalingType
from opendaq.opendaq import Scheduler
from opendaq.opendaq import SelectionProperty
from opendaq.opendaq import SelectionPropertyBuilder
from opendaq.opendaq import ServerType
from opendaq.opendaq import Signal
from opendaq.opendaq import SignalWithDescriptor
from opendaq.opendaq import SimpleType
from opendaq.opendaq import SparseSelectionProperty
from opendaq.opendaq import SparseSelectionPropertyBuilder
from opendaq.opendaq import StdErrLoggerSink
from opendaq.opendaq import StdOutLoggerSink
from opendaq.opendaq import StreamReader
from opendaq.opendaq import StreamReaderFromExisting
from opendaq.opendaq import String
from opendaq.opendaq import StringProperty
from opendaq.opendaq import StringPropertyBuilder
from opendaq.opendaq import Struct
from opendaq.opendaq import StructBuilder
from opendaq.opendaq import StructBuilderFromStruct
from opendaq.opendaq import StructFromBuilder
from opendaq.opendaq import StructProperty
from opendaq.opendaq import StructPropertyBuilder
from opendaq.opendaq import StructType
from opendaq.opendaq import StructTypeNoDefaults
from opendaq.opendaq import SubscriptionEventArgs
from opendaq.opendaq import SubscriptionEventType
from opendaq.opendaq import Tags
from opendaq.opendaq import TailReader
from opendaq.opendaq import TailReaderFromExisting
from opendaq.opendaq import Task
from opendaq.opendaq import TaskGraph
from opendaq.opendaq import TimeBlockReader
from opendaq.opendaq import TimeStreamReader
from opendaq.opendaq import TimeTailReader
from opendaq.opendaq import TypeManager
from opendaq.opendaq import Unit
from opendaq.opendaq import UnitBuilder
from opendaq.opendaq import UnitBuilderFromExisting
from opendaq.opendaq import Validator
from opendaq.opendaq import VisibleSearchFilter
from opendaq.opendaq import clear_error_info
from opendaq.opendaq import get_tracked_object_count
from opendaq.opendaq import print_tracked_objects
import os as os
from . import opendaq
__all__ = ['AndSearchFilter', 'AnySearchFilter', 'ArgumentInfo', 'BaseObject', 'BasicFileLoggerSink', 'BlockReader', 'BlockReaderFromExisting', 'BlockReaderStatus', 'BoolProperty', 'BoolPropertyBuilder', 'Boolean', 'CallableInfo', 'Client', 'CmdLineArgsConfigProvider', 'Coercer', 'ComplexNumber', 'Component', 'ComponentStatusContainer', 'Connection', 'ConstantDataRule', 'Context', 'CoreType', 'CustomSearchFilter', 'DataDescriptorBuilder', 'DataDescriptorBuilderFromExisting', 'DataDescriptorChangedEventPacket', 'DataDescriptorFromBuilder', 'DataPacket', 'DataPacketWithDomain', 'DataRule', 'DataRuleBuilder', 'DataRuleBuilderFromExisting', 'DataRuleFromBuilder', 'DataRuleType', 'DeviceDomain', 'DeviceInfoConfig', 'DeviceInfoConfigWithCustomSdkVersion', 'DeviceType', 'Dict', 'DictProperty', 'DictPropertyBuilder', 'Dimension', 'DimensionBuilder', 'DimensionBuilderFromExisting', 'DimensionFromBuilder', 'DimensionRule', 'DimensionRuleBuilder', 'DimensionRuleBuilderFromExisting', 'DimensionRuleFromBuilder', 'DimensionRuleType', 'Enumeration', 'EnumerationProperty', 'EnumerationPropertyBuilder', 'EnumerationType', 'EnumerationTypeWithValues', 'EnumerationWithType', 'EnvConfigProvider', 'EvalValue', 'EvalValueArgs', 'EvalValueFunc', 'EventArgs', 'EventPacket', 'ExcludedTagsSearchFilter', 'ExplicitDataRule', 'ExplicitDomainDataRule', 'ExternalAllocator', 'Float', 'FloatProperty', 'FloatPropertyBuilder', 'Folder', 'FolderWithItemType', 'Function', 'FunctionBlockType', 'FunctionProperty', 'FunctionPropertyBuilder', 'IAllocator', 'IArgumentInfo', 'IAwaitable', 'IBaseObject', 'IBlockReader', 'IBlockReaderStatus', 'IBoolean', 'ICallableInfo', 'IChannel', 'ICoercer', 'IComplexNumber', 'IComponent', 'IComponentPrivate', 'IComponentStatusContainer', 'IComponentStatusContainerPrivate', 'IComponentType', 'IConfigProvider', 'IConnection', 'IContext', 'IDataDescriptor', 'IDataDescriptorBuilder', 'IDataPacket', 'IDataRule', 'IDataRuleBuilder', 'IDevice', 'IDeviceDomain', 'IDeviceInfo', 'IDeviceInfoConfig', 'IDeviceType', 'IDict', 'IDimension', 'IDimensionBuilder', 'IDimensionRule', 'IDimensionRuleBuilder', 'IEnumeration', 'IEnumerationType', 'IEvalValue', 'IEventArgs', 'IEventPacket', 'IFloat', 'IFolder', 'IFolderConfig', 'IFunction', 'IFunctionBlock', 'IFunctionBlockType', 'IGraphVisualization', 'IInputPort', 'IInputPortConfig', 'IInputPortNotifications', 'IInstance', 'IInstanceBuilder', 'IInteger', 'IIterable', 'IIterator', 'IList', 'ILogger', 'ILoggerComponent', 'ILoggerSink', 'ILoggerThreadPool', 'IMirroredSignalConfig', 'IMirroredSignalPrivate', 'IModule', 'IModuleManager', 'INumber', 'IOwnable', 'IPacket', 'IPacketDestructCallback', 'IPacketReader', 'IProcedure', 'IProperty', 'IPropertyBuilder', 'IPropertyObject', 'IPropertyObjectClass', 'IPropertyObjectClassBuilder', 'IPropertyObjectProtected', 'IPropertyValueEventArgs', 'IRange', 'IRatio', 'IReader', 'IReaderStatus', 'IRemovable', 'ISampleReader', 'IScaling', 'IScalingBuilder', 'IScheduler', 'ISearchFilter', 'IServer', 'IServerCapability', 'IServerType', 'ISignal', 'ISignalConfig', 'ISignalEvents', 'ISimpleType', 'IStreamReader', 'IStreaming', 'IString', 'IStruct', 'IStructBuilder', 'IStructType', 'ISubscriptionEventArgs', 'ITags', 'ITagsPrivate', 'ITailReader', 'ITask', 'ITaskGraph', 'IType', 'ITypeManager', 'IUnit', 'IUnitBuilder', 'IValidator', 'InputPort', 'Instance', 'InstanceBuilder', 'InstanceFromBuilder', 'IntProperty', 'IntPropertyBuilder', 'Integer', 'InterfaceIdSearchFilter', 'IoFolder', 'JsonConfigProvider', 'LinearDataRule', 'LinearDimensionRule', 'LinearScaling', 'List', 'ListDimensionRule', 'ListProperty', 'ListPropertyBuilder', 'LocalIdSearchFilter', 'LogLevel', 'LogarithmicDimensionRule', 'Logger', 'LoggerComponent', 'LoggerThreadPool', 'MallocAllocator', 'MockSignal', 'ModuleManager', 'ModuleManagerMultiplePaths', 'NotSearchFilter', 'OPENDAQ_CWD', 'OPENDAQ_MODULES_DIR', 'ObjectProperty', 'ObjectPropertyBuilder', 'OrSearchFilter', 'PacketReader', 'PacketReaderFromPort', 'PacketReadyNotification', 'PacketType', 'Procedure', 'PropertyBuilder', 'PropertyEventType', 'PropertyObject', 'PropertyObjectClassBuilder', 'PropertyObjectClassBuilderWithManager', 'PropertyObjectClassFromBuilder', 'PropertyObjectWithClassAndManager', 'PropertyValueEventArgs', 'ProtocolType', 'Range', 'Ratio', 'RatioProperty', 'RatioPropertyBuilder', 'ReadMode', 'ReadStatus', 'ReadTimeoutType', 'ReaderStatus', 'RecursiveSearchFilter', 'ReferenceProperty', 'ReferencePropertyBuilder', 'RequiredTagsSearchFilter', 'RotatingFileLoggerSink', 'SampleType', 'ScaledSampleType', 'Scaling', 'ScalingBuilder', 'ScalingBuilderFromExisting', 'ScalingFromBuilder', 'ScalingType', 'Scheduler', 'SelectionProperty', 'SelectionPropertyBuilder', 'ServerType', 'Signal', 'SignalWithDescriptor', 'SimpleType', 'SparseSelectionProperty', 'SparseSelectionPropertyBuilder', 'StdErrLoggerSink', 'StdOutLoggerSink', 'StreamReader', 'StreamReaderFromExisting', 'String', 'StringProperty', 'StringPropertyBuilder', 'Struct', 'StructBuilder', 'StructBuilderFromStruct', 'StructFromBuilder', 'StructProperty', 'StructPropertyBuilder', 'StructType', 'StructTypeNoDefaults', 'SubscriptionEventArgs', 'SubscriptionEventType', 'Tags', 'TailReader', 'TailReaderFromExisting', 'Task', 'TaskGraph', 'TimeBlockReader', 'TimeStreamReader', 'TimeTailReader', 'TypeManager', 'Unit', 'UnitBuilder', 'UnitBuilderFromExisting', 'Validator', 'VisibleSearchFilter', 'clear_error_info', 'get_tracked_object_count', 'opendaq', 'os', 'print_tracked_objects']
def Instance(*args) -> opendaq.IInstance:
    ...
OPENDAQ_CWD: str = '/__w/openDAQ/openDAQ/build/pip/packages'
OPENDAQ_MODULES_DIR: str = '/__w/openDAQ/openDAQ/build/pip/packages/opendaq'
